<template>
  <div>
    <v-select
      :items="groups"
      item-value="key"
      item-text="name"
      v-model="group"
    ></v-select>
    <div>
      Total Projects <v-chip>{{ projects.length }}</v-chip>
    </div>
    <v-btn @click="postHooksAll()">Asignar webhooks</v-btn>
    <v-simple-table fixed-header height="700px">
      <template v-slot:default>
        <thead>
          <tr>
            <th class="text-left">
              Project Name
            </th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="item in projects" :key="item.name">
            <td>{{ item.name }}</td>
          </tr>
        </tbody>
      </template>
    </v-simple-table>
  </div>
</template>
<script>
import axios from "axios";
const axiosGitlab = axios.create({
  baseURL: "http://10.89.86.56",
});
export default {
  name: "Component-Appi",
  data() {
    return {
      projects: [],
      group: 41,
      groups: [
        {
          key: 41,
          name: "Plataforma Franquicia / web",
        },
        {
          key: 42,
          name: "Plataforma Franquicia / web / franquicia",
        },
        {
          key: 37,
          name: "Plataforma Franquicia V2 / web",
        },
        {
          key: 38,
          name: "Plataforma Franquicia V2 / web / Modelo de Negocio",
        },
      ],
    };
  },
  watch: {
    group() {
      this.getData();
    },
  },
  methods: {
    getData() {
      const self = this;
      var config = {
        method: "get",
        url:
          "http://10.89.86.56/api/v4/groups/" + this.group + "/?per_page=150",
        headers: {
          "PRIVATE-TOKEN": "n7uRFW3FwWDkx8RESYNp",
        },
      };
      axiosGitlab(config)
        .then(function(response) {
          self.projects = response.data.projects;
        })
        .catch(function(error) {
          console.log(error);
        });
    },
    postHooksAll() {
      this.projects.forEach((item) => {
        this.postHook(item);
      });
    },
    postHook(project) {
      var data = JSON.stringify({
        url: "http://10.89.86.56:8181/project/" + project.name,
        enable_ssl_verification: true,
        push_events: true,
        push_events_branch_filter: "master",
      });
      var config = {
        method: "post",
        url: "http://10.89.86.56/api/v4/projects/" + project.id + "/hooks",
        headers: {
          "PRIVATE-TOKEN": "n7uRFW3FwWDkx8RESYNp",
          "Content-Type": "application/json",
        },
        data: data,
      };
      axiosGitlab(config)
        .then(function(response) {
          console.log(JSON.stringify(response.data));
        })
        .catch(function(error) {
          console.log(error);
        });
    },
  },
  created() {
    this.getData();
  },
};
</script>
